﻿Imports System.IO
Imports System.Text

Public Class FileReadWriter
   Private _Encoding As Encoding
   Private _Path As String

   ''' <summary> count&lt;1 makes me read the whole file. Note! enc may change to the
   ''' correct Encoding, according to the ByteOrderMarks</summary>
   Public Shared Function Read(ByVal path As String, ByVal count As Integer, _
         Optional ByRef enc As Encoding = Nothing) As String
      If enc Is Nothing Then enc = Encoding.Default
      Using rd As New StreamReader(path, enc, True)
         Try
            If count < 1 Then Return rd.ReadToEnd
            Dim buf(count - 1) As Char
            count = rd.Read(buf, 0, count)
            Return New String(buf, 0, count)
         Finally
            enc = rd.CurrentEncoding
         End Try
      End Using
   End Function

   Public Shared Function ChangeEncoding(ByVal path As String, ByVal enc As Encoding, _
         Optional ByVal defaultEncoding As Encoding = Nothing) As Boolean
      Using str As New FileStream(path, FileMode.Open, FileAccess.ReadWrite), _
            rd As New StreamReader(str, If(defaultEncoding, Encoding.Default), True)
         Dim content = rd.ReadToEnd
         Dim readEnc = rd.CurrentEncoding
         If readEnc.Equals(enc) Then Return False
         str.Position = 0
         Using wr As New StreamWriter(str, enc)
            wr.Write(content)
         End Using
      End Using
      Return True
   End Function

   Public Function Read(ByVal path As String, Optional ByVal defaultEncoding As Encoding = Nothing) As String
      _Path = path
      _Encoding = defaultEncoding
      Return Read(path, -1, _Encoding)
   End Function

   Public Sub Write(ByVal content As String, Optional ByVal target As String = "")
      If target = "" Then target = _Path
      File.WriteAllText(target, content, _Encoding)
   End Sub

End Class
